MultiNetv11<-function(HSQC,HSQCTOCSY,COSY1H=NA,COSY13C=NA,errH=0.03,errC=0.53)	# each peak data(NAME,F2,F1) and error range
{
# [1] correlation (square)
#
#  ()\   ;HSQC
#    |   |    ;HSQC-TOCSY
#   \()   
#

unique(HSQC[,2:3])->HSQC->hsqc
cbind(seq(dim(HSQC)[1]),HSQC)->HSQC

unique(HSQCTOCSY[,2:3])->HSQCTOCSY->hsqctocsy
cbind(seq(dim(HSQCTOCSY)[1]),HSQCTOCSY)->HSQCTOCSY

cosy1h<-NA
if(length(COSY1H)>1){
unique(COSY1H[,2:3])->COSY1H->cosy1h
cbind(seq(dim(COSY1H)[1]),COSY1H)->COSY1H
}

cosy13c<-NA
if(length(COSY13C)>1){
unique(COSY13C[,2:3])->COSY13C->cosy13c
cbind(seq(dim(COSY13C)[1]),COSY13C)->COSY13C
}

A <- HSQCTOCSY
B <- errH
C <- errC
data <- A[,-1]
NAME <- A[,1]
DATA <- as.matrix(data)
N <- dim(DATA)[1]
MAdata1 <- matrix(0, N, N)
MAdata3 <- matrix(0, N, N)

# 1H connection
for (i in 1:N)
for (j in i:N)
if(abs(DATA[i,1] - DATA[j,1]) < B){
	MAdata1[i,j] = 1
	} else {
	MAdata1[i,j] = 0
}
diag(MAdata1)<-0
LIST1 <- which(MAdata1 ==1, arr.ind=TRUE)
L1N <- dim(LIST1)[1]

# 13C connection
for (i in 1:N)
for (j in i:N)
if(abs(DATA[i,2] - DATA[j,2]) < C){
	MAdata3[i,j] = 1
	} else {
	MAdata3[i,j] = 0
}
diag(MAdata3)<-0
LIST2 <- which(MAdata3 ==1, arr.ind=TRUE)
L2N <- dim(LIST2)[1]

LIST3 <- matrix(0,0,3)
colnames(LIST3) <- c("same","diag1","diag2")

# for(i in 1:L1N)
# for(j in 1:L2N)
# if( LIST1[i,1] == LIST2[j,1] ){
# LIST3 <- rbind(LIST3, t(matrix(c(LIST1[i,1], LIST1[i,2], LIST2[j,2]))))
# } else if (LIST1[i,1] == LIST2[j,2]){
# LIST3 <- rbind(LIST3, t(matrix(c(LIST1[i,1], LIST1[i,2], LIST2[j,1]))))
# } else if (LIST1[i,2] == LIST2[j,1]){
# LIST3 <- rbind(LIST3, t(matrix(c(LIST1[i,2], LIST1[i,1], LIST2[j,2]))))
# } else if (LIST1[i,2] == LIST2[j,2]){
# LIST3 <- rbind(LIST3, t(matrix(c(LIST1[i,2], LIST1[i,1], LIST2[j,1]))))
# }

exGrid <- expand.grid(seq(1:L1N),seq(1:L2N))

lis31 <- which(LIST1[exGrid[,1],1] == LIST2[exGrid[,2],1])
if(length(lis31)!=0){
LIS31 <- cbind(LIST1[exGrid[lis31,1],1],LIST1[exGrid[lis31,1],2],LIST2[exGrid[lis31,2],2])
}
lis32 <- which(LIST1[exGrid[,1],1] == LIST2[exGrid[,2],2])
if(length(lis32)!=0){
LIS32 <- cbind(LIST1[exGrid[lis32,1],1],LIST1[exGrid[lis32,1],2],LIST2[exGrid[lis32,2],1])
}
lis33 <- which(LIST1[exGrid[,1],2] == LIST2[exGrid[,2],1])
if(length(lis33)!=0){
LIS33 <- cbind(LIST1[exGrid[lis33,1],2],LIST1[exGrid[lis33,1],1],LIST2[exGrid[lis33,2],2])
}
lis34 <- which(LIST1[exGrid[,1],2] == LIST2[exGrid[,2],2])
if(length(lis34)!=0){
LIS34 <- cbind(LIST1[exGrid[lis34,1],2],LIST1[exGrid[lis34,1],1],LIST2[exGrid[lis34,2],1])
}
if( length(lis31)!=0 || length(lis32)!=0 || length(lis33)!=0 || length(lis34)!=0 ){
LIST3 <- rbind(LIST3,LIS31,LIS32,LIS33,LIS34)
}

L3N <- dim(LIST3)[1]
L3N2 <- dim(LIST3)[2]
LIST4 <- matrix(NA,L3N,L3N2)

# verification of correlation (using HSQC, COSY, TOCSY)

# HSQC
for(i in 1:L3N){
for(j in 1:3){
LLL1 <- which( abs(hsqctocsy[LIST3[i,j],1]-hsqc[,1])<B )
LLL2 <- which( abs(hsqctocsy[LIST3[i,j],2]-hsqc[,2])<C )
if( length(LLL1) >0 && length(LLL2) >0 ){
LLL3 <- intersect(LLL1,LLL2)
if( length(LLL3) ==1 ){
LIST4[i,j] <- LLL3
} else if(length(LLL3) >1){
lll1<-abs(hsqctocsy[LIST3[i,j],1]-hsqc[,1])
lll2<-abs(hsqctocsy[LIST3[i,j],2]-hsqc[,2])
lll3<-sqrt((lll1^2)+(lll2^2))[LLL3]
lll4<-which(lll3==min(lll3))
LIST4[i,j] <- LLL3[lll4]
}}
}}
usedHSQC <- sort(unique(c(LIST4)))
colnames(LIST4) <- c("sameHSQC","diag1HSQC","diag2HSQC")
LIST7 <- cbind(LIST3,LIST4)
lll5 <- which(is.na(LIST4[,2]))
lll6 <- which(is.na(LIST4[,3]))
if( length(lll5)>0 || length(lll6)>0 ){
lll7 <- sort(unique(c(lll5,lll6)))
LIST7 <- LIST7[-lll7,]
}

# 1H correlation
if(length(cosy1h)>1){
L7N <- nrow(LIST7)
N1H <- nrow(cosy1h)
LIST5 <- matrix(NA,L7N,1)
for(i in 1:L7N)
for(j in 1:N1H)
if( (abs(hsqc[LIST7[i,5],1]-cosy1h[j,1]) < B && abs(hsqc[LIST7[i,6],1]-cosy1h[j,2]) < B) ||
    (abs(hsqc[LIST7[i,5],1]-cosy1h[j,2]) < B && abs(hsqc[LIST7[i,6],1]-cosy1h[j,1]) < B) ){
LIST5[i,] <- c(j)
}
colnames(LIST5) <- c("COSY1H")
LIST7 <- cbind(LIST7,LIST5)
LIST7 <- LIST7[(!is.na(LIST7[,7])),]
}

# 13C correlation
if(length(cosy13c)>1){
L7N <- nrow(LIST7)
N13C <- nrow(cosy13c)
LIST6 <- matrix(NA,L7N,1)
for(i in 1:L7N)
for(j in 1:N13C)
if( (abs(hsqc[LIST7[i,5],2]-cosy13c[j,1]) < C && abs(hsqc[LIST7[i,6],2]-cosy13c[j,2]) < C) ||
    (abs(hsqc[LIST7[i,5],2]-cosy13c[j,2]) < C && abs(hsqc[LIST7[i,6],2]-cosy13c[j,1]) < C) ){
LIST6[i,] <- c(j)
}
colnames(LIST6) <- c("COSY13C")
LIST7 <- cbind(LIST7,LIST6)
LIST7 <- LIST7[(!is.na(LIST7[,7])),]
}

# [2] single binding of the rest of HSQC
# 
#  
#  |   and  \
#  
#
#

only1Hcon <- matrix(0,1,2)
only13Ccon <- matrix(0,1,2)
HSQC2 <- c()
hsqc2 <- usedHSQC
hsqc2 <- sort(unique(hsqc2))
hsqc3 <- hsqc[-hsqc2,]
if(dim(hsqc3)[1]==1){hsqc3 <- t(matrix(hsqc3))}
hsqc3LEN <- dim(hsqc3)[1]
CClist <- c()

if(dim(hsqc3)[1]>0){

if(length(cosy1h)>1){
cosy1h <- as.matrix(COSY1H[,2:3])
cosy1hLEN <- dim(cosy1h)[1]
for(i in 1:cosy1hLEN)
for(j in 1:hsqc3LEN)
for(k in j:hsqc3LEN)
if( abs(hsqc3[j,2]-hsqc3[k,2]) <C && (j != k) &&
(( abs(cosy1h[i,1]-hsqc3[j,1]) <B ) || ( abs(cosy1h[i,1]-hsqc3[k,1]) <B )) && (( abs(cosy1h[i,2]-hsqc3[j,1]) <B ) || ( abs(cosy1h[i,2]-hsqc3[k,1]) <B )) ){
only1Hcon <- rbind(only1Hcon,matrix(c(j,k),1,2))
HSQC2 <- append(HSQC2,c(j,k))
}}

if(length(cosy13c)>1){
cosy13c <- as.matrix(COSY13C[,2:3])
cosy13cLEN <- dim(cosy13c)[1]
CClist <- c()
for(i in 1:cosy13cLEN)
for(j in 1:hsqc3LEN)
for(k in j:hsqc3LEN)
if( abs(hsqc3[j,1]-hsqc3[k,1]) <B && (j != k) &&
(( abs(cosy13c[i,1]-hsqc3[j,2]) <C ) || ( abs(cosy13c[i,1]-hsqc3[k,2]) <C )) && (( abs(cosy13c[i,2]-hsqc3[j,2]) <C ) || ( abs(cosy13c[i,2]-hsqc3[k,2]) <C )) ){
only13Ccon <- rbind(only13Ccon,matrix(c(j,k),1,2))
HSQC2 <- append(HSQC2,c(j,k))
CClist <- c(CClist,i)
}}
}

only1Hcon <- only1Hcon[-1,]
only13Ccon <- only13Ccon[-1,]

# [3] the rest of the HSQC (single)
#
#  
#
#

if(length(HSQC2)<1 && length(hsqc3)>0){HSQC4 <- hsqc3}
if(length(HSQC2)<1 && length(hsqc3)<1){HSQC4 <- matrix(0,0,2)}
if(length(HSQC2)>0 && length(hsqc3)>2){HSQC4 <- hsqc3[-HSQC2,]}
if(length(HSQC2)>0 && length(hsqc3)==2){
hsqc3 <- t(matrix(hsqc3))
HSQC4 <- hsqc3[-HSQC2,]
}

# [4] the rest of the 13C COSY (quaternary carbon)
#
#  
#    _
#      
#

if(length(cosy13c)>1){
cosy13c2 <- cosy13c[-(sort(unique(c(LIST6,CClist)))),]
if(length(cosy13c2)>1){
DIM13C <- nrow(cosy13c2)
selfcor <- c()
for(i in 1:DIM13C){
if( abs(cosy13c2[i,1] - cosy13c2[i,2])< C ){
selfcor <- c(selfcor,i)
}}
if(length(selfcor)>0){cosy13c2 <- cosy13c2[-selfcor,]}
}
if(length(cosy13c2)==2){cosy13c2 <- t(matrix(cosy13c2))}
} else {cosy13c2<-matrix(0,0,2)}

# [5] grouping
#
#      \
#      |
#  \
#  | 
#  
#

L7N <- nrow(LIST7)
MAT1 <- matrix(0,L7N,L7N)
for(i in 1:L7N)
for(j in i:L7N)
if( length(intersect(c(LIST7[i,5:6]),c(LIST7[j,5:6]))) >0 ){
MAT1[i,j] <-c(1)
}

MAT2 <- t(MAT1)+MAT1
diag(MAT2) <- 1
MAT3 <- MAT2

MATLIS <- list()
MATLIS[[1]] <- c(1)
for(i in 2:100)
MATLIS[[i]] <- c(0)

for(i in 2:100){
if(sum(MATLIS[[i-1]])==0) break
for(j in 1:L7N)
for(k in j:L7N)
if(MAT3[j,k]==1 && sum(abs(MAT3[j,]-MAT3[k,])) != 0){
index1 <- which(MAT3[j,]==1)
index2 <- which(MAT3[k,]==1)
MAT3[j,index2] <- c(1)
MAT3[k,index1] <- c(1)
MATLIS[[i]] <- c(MATLIS[[i]],1)	
}}

MAT4 <- unique(MAT3)

# [6] connection with quaternary carbon


RESULTnoLIST <- list()
if(length(only1Hcon) >0 ){
RESULTnoLIST$HSQC1H <- only1Hcon}
if(length(only13Ccon) >0 ){
RESULTnoLIST$HSQC13C <- only13Ccon}
if(length(HSQC4) >0 ){
RESULTnoLIST$HSQConly <- HSQC4}
RESULTnoLIST$HSQCTOCSY <- LIST7
if(length(cosy13c2) >0 ){
RESULTnoLIST$COCSY13C <- cosy13c2}

RESULTcoordinate <- list()
if(dim(HSQC4)[1]>0){
RESULTcoordinate$HSQConly <- list()
for(i in 1:dim(HSQC4)[1])
RESULTcoordinate$HSQConly[[i]] <- matrix(HSQC4[i,],1,2)
RESULTcoordinate$HSQConly[[i]] <- unique(RESULTcoordinate$HSQConly[[i]])
}
if(dim(only1Hcon)[1]>0){
RESULTcoordinate$HSQC1H <- list()
for(i in 1:dim(only1Hcon)[1])
RESULTcoordinate$HSQC1H[[i]] <- rbind(hsqc3[only1Hcon[i,1],],hsqc3[only1Hcon[i,2],])
RESULTcoordinate$HSQC1H[[i]] <- unique(RESULTcoordinate$HSQC1H[[i]])
}
if(dim(only13Ccon)[1]>0){
RESULTcoordinate$HSQC13C <- list()
for(i in 1:dim(only13Ccon)[1])
RESULTcoordinate$HSQC13C[[i]] <- rbind(hsqc3[only13Ccon[i,1],],hsqc3[only13Ccon[i,2],])
RESULTcoordinate$HSQC13C[[i]] <- unique(RESULTcoordinate$HSQC13C[[i]])
}
if(dim(cosy13c2)[1]>0){
RESULTcoordinate$COCSY13C <- list()
for(i in 1:dim(cosy13c2)[1])
RESULTcoordinate$COCSY13C[[i]] <- matrix(cosy13c2[i,],1,2)
RESULTcoordinate$COCSY13C[[i]] <- unique(RESULTcoordinate$COCSY13C[[i]])
}
RESULTcoordinate$HSQCTOCSY <- list()
for(i in 1:dim(MAT4)[1])
RESULTcoordinate$HSQCTOCSY[[i]] <- unique(rbind(hsqctocsy[LIST7[which(MAT4[i,]==1),1],],
						hsqctocsy[LIST7[which(MAT4[i,]==1),2],],
						hsqctocsy[LIST7[which(MAT4[i,]==1),3],]))


COUNT <- c(length(RESULTcoordinate$HSQConly),length(RESULTcoordinate$HSQC1H),length(RESULTcoordinate$HSQC13C),length(RESULTcoordinate$COCSY13C),length(RESULTcoordinate$HSQCTOCSY))
COUNT <- t(matrix(COUNT))
colnames(COUNT) <- c("HSQConly","HSQC1H","HSQC13C","COCSY13C","HSQCTOCSY")


# 13C COSY vs [2] single binding of the rest of HSQC (1H)
if(length(RESULTcoordinate$COCSY13C)>0 && length(RESULTcoordinate$HSQC1H)>0){
COSY13CvsHSQC1H <- matrix(0,length(RESULTcoordinate$COCSY13C),length(RESULTcoordinate$HSQC1H))
for(i in 1:length(RESULTcoordinate$COCSY13C))
for(j in 1:length(RESULTcoordinate$HSQC1H))
if(abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,1])-
       as.numeric(RESULTcoordinate$HSQC1H[[j]][1,2])) <C || 
   abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,1])-
       as.numeric(RESULTcoordinate$HSQC1H[[j]][2,2])) <C ||
   abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,2])-
       as.numeric(RESULTcoordinate$HSQC1H[[j]][1,2])) <C ||
   abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,2])-
       as.numeric(RESULTcoordinate$HSQC1H[[j]][2,2])) <C
){
COSY13CvsHSQC1H[i,j] <- c(1)
}
COSY13CvsHSQC1Hlist <- which(COSY13CvsHSQC1H ==1, arr.ind=TRUE)
colnames(COSY13CvsHSQC1Hlist) <- c("COSY13C[[n]]","HSQC1H[[n]]")
} else {COSY13CvsHSQC1Hlist <- c()}

# 13C COSY vs [2] single binding of the rest of HSQC (13C)
if(length(RESULTcoordinate$COCSY13C)>0 && length(RESULTcoordinate$HSQC13C)>0){
COSY13CvsHSQC13C <- matrix(0,length(RESULTcoordinate$COCSY13C),length(RESULTcoordinate$HSQC13C))
for(i in 1:length(RESULTcoordinate$COCSY13C))
for(j in 1:length(RESULTcoordinate$HSQC13C))
if(abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,1])-
       as.numeric(RESULTcoordinate$HSQC13C[[j]][1,2])) <C || 
   abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,1])-
       as.numeric(RESULTcoordinate$HSQC13C[[j]][2,2])) <C ||
   abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,2])-
       as.numeric(RESULTcoordinate$HSQC13C[[j]][1,2])) <C ||
   abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,2])-
       as.numeric(RESULTcoordinate$HSQC13C[[j]][2,2])) <C
){
COSY13CvsHSQC13C[i,j] <- c(1)
}
COSY13CvsHSQC13Clist <- which(COSY13CvsHSQC13C ==1, arr.ind=TRUE)
colnames(COSY13CvsHSQC13Clist) <- c("COSY13C[[n]]","HSQC13C[[n]]")
} else {COSY13CvsHSQC13Clist <- c()}

# 13C COSY vs [3] the rest of the HSQC (single)
if(length(RESULTcoordinate$COCSY13C)>0 && length(RESULTcoordinate$HSQConly)>0){
COSY13CvsHSQConly <- matrix(0,length(RESULTcoordinate$COCSY13C),length(RESULTcoordinate$HSQConly))
for(i in 1:length(RESULTcoordinate$COCSY13C))
for(j in 1:length(RESULTcoordinate$HSQConly))
if(abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,1])-
       as.numeric(RESULTcoordinate$HSQConly[[j]][1,2])) <C || 
   abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,2])-
       as.numeric(RESULTcoordinate$HSQConly[[j]][1,2])) <C
){
COSY13CvsHSQConly[i,j] <- c(1)
}
COSY13CvsHSQConlylist <- which(COSY13CvsHSQConly ==1, arr.ind=TRUE)
colnames(COSY13CvsHSQConlylist) <- c("COSY13C[[n]]","HSQConly[[n]]")
} else {COSY13CvsHSQConlylist <- c()}


# 13C COSY vs [1] correlation (square)
if(length(RESULTcoordinate$COCSY13C)>0 && length(RESULTcoordinate$HSQCTOCSY)>0){
COSY13CvsHSQCTOCSY <- matrix(0,length(RESULTcoordinate$COCSY13C),length(RESULTcoordinate$HSQCTOCSY))
for(i in 1:length(RESULTcoordinate$COCSY13C))
for(j in 1:length(RESULTcoordinate$HSQCTOCSY))
if( sum(abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,1])-
            as.numeric(RESULTcoordinate$HSQCTOCSY[[j]][,2])) <C ) >0 ||
    sum(abs(as.numeric(RESULTcoordinate$COCSY13C[[i]][1,2])-
            as.numeric(RESULTcoordinate$HSQCTOCSY[[j]][,2])) <C ) >0
){
COSY13CvsHSQCTOCSY[i,j] <- c(1)
}
COSY13CvsHSQCTOCSYlist <- which(COSY13CvsHSQCTOCSY ==1, arr.ind=TRUE)
colnames(COSY13CvsHSQCTOCSYlist) <- c("COSY13C[[n]]","HSQCTOCSY[[n]]")
} else {COSY13CvsHSQCTOCSYlist <- c()}


# summary

RESULT <- list()
RESULT$RESULTnoLIST <- RESULTnoLIST
RESULT$RESULTcoordinate <- RESULTcoordinate
RESULT$GroupCount <- COUNT
rownames(RESULT$GroupCount) <- c("")
RESULT$Connect4C <- list()
RESULT$Connect4C$COSY13CvsHSQC1Hlist <- COSY13CvsHSQC1Hlist
RESULT$Connect4C$COSY13CvsHSQC13Clist <- COSY13CvsHSQC13Clist
RESULT$Connect4C$COSY13CvsHSQConlylist <- COSY13CvsHSQConlylist
RESULT$Connect4C$COSY13CvsHSQCTOCSYlist <- COSY13CvsHSQCTOCSYlist


# plot

dev.set(1)
par(mar=c(5,1,5,5))
if(sqrt(COUNT[5])-round(sqrt(COUNT[5]))==0){
par(mfrow=c(sqrt(COUNT[5]),sqrt(COUNT[5])))
} else if(sqrt(COUNT[5]) > round(sqrt(COUNT[5])) ){
par(mfrow=c(round(sqrt(COUNT[5])),round(sqrt(COUNT[5]))+1))
} else if(sqrt(COUNT[5]) < round(sqrt(COUNT[5])) ){
par(mfrow=c(round(sqrt(COUNT[5])),round(sqrt(COUNT[5]))))
}

for(i in 1:COUNT[5]){
plot(hsqctocsy[,1:2],
xlim=c(max(RESULTcoordinate$HSQCTOCSY[[i]][,1])+1,min(RESULTcoordinate$HSQCTOCSY[[i]][,1])-1),
ylim=c(max(RESULTcoordinate$HSQCTOCSY[[i]][,2])+20,min(RESULTcoordinate$HSQCTOCSY[[i]][,2])-20),
pch=16,col="blue",yaxt="n",ylab="")
par(new=T)

countCH <- which(MAT4[i,]==1)
for(j in 1:length(countCH)){
lines(c(hsqctocsy[LIST7[countCH[j],1],1], hsqctocsy[LIST7[countCH[j],2],1]),
      c(hsqctocsy[LIST7[countCH[j],1],2], hsqctocsy[LIST7[countCH[j],2],2]),col="black")
lines(c(hsqctocsy[LIST7[countCH[j],1],1], hsqctocsy[LIST7[countCH[j],3],1]),
      c(hsqctocsy[LIST7[countCH[j],1],2], hsqctocsy[LIST7[countCH[j],3],2]),col="black")
}

par(new=T)
plot(RESULTcoordinate$HSQCTOCSY[[i]],
xlim=c(max(RESULTcoordinate$HSQCTOCSY[[i]][,1])+1,min(RESULTcoordinate$HSQCTOCSY[[i]][,1])-1),
ylim=c(max(RESULTcoordinate$HSQCTOCSY[[i]][,2])+20,min(RESULTcoordinate$HSQCTOCSY[[i]][,2])-20),
cex=1.5,pch=16,col="blue",yaxt="n",ylab="")
par(new=T)
plot(hsqc[,1:2],
xlim=c(max(RESULTcoordinate$HSQCTOCSY[[i]][,1])+1,min(RESULTcoordinate$HSQCTOCSY[[i]][,1])-1),
ylim=c(max(RESULTcoordinate$HSQCTOCSY[[i]][,2])+20,min(RESULTcoordinate$HSQCTOCSY[[i]][,2])-20),
pch=16,col="red",yaxt="n",ylab="",main=paste("Group No.",i))
axis(4)
mtext("13C", side = 4, line = 3)
}

print(RESULT$GroupCount)
return(RESULT)

}
